// Returns true if executed on an iBASE appliance
bool isIbase();

// Returns true if executed on a Nexcom appliance
bool isNexcom();

// Sets the status LED of the iBASE appliance to on (bit=true) or off (bit=false)
void setLedBit(bool bit);

/* Sets the LAN bypass mode:
 true --> LAN3 and LAN4 connected directly to each other
 false --> LAN3 and LAN4 connected to the internal network cards */
void setLanBypass(bool mode);

/* Disables the LAN bypass watchdog.
 Attention: if the watchdog has already triggered when this is being called,
 it is _not_ automatically reset to normal mode by disabling the watchdog. You
 need to call setLanBypass(false) to reset back to "normal" state. */
void lanBypassWatchdogDisable();

/* Sends the alive signal to the LAN bypass watchdog. The interval value can
 be set using the following table:

 Possible values for this watchdog "alive" signal:
 Value     Time/sec
 1F        0
 1E        2
 1D        4
 1C        6
 ...........
 02        58
 01        60
 00        62
 */
// But we use the lowest frequency as default value:
#define watchdog_enable_value 0x1e
void lanBypassWatchdogSendAlive(unsigned char interval);
