#include <sys/io.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <time.h>

#include "appliance.h"

int main(int argc, char* argv[])
{
    int param;
    struct timespec sleep;

    if (argc != 2) {
	printf("Need value !\n");
        printf("0 ... bypass off\n");
	printf("1 ... bypass on\n");
	printf("2 ... bypass watchdog disable\n");
        printf("3 ... bypass watchdog alive signal\n");
        printf("4 ... enable watchdog and start to send alive signals (loops)\n");
        return 2;
    }
    param = atoi(argv[1]);
    if (param < 0) {
	printf("Invalid value !\n");
        return 3;
    }

    if (! isIbase()) {
	printf("This is not an iBASE appliance. Can not interface with LAN bypass!\n");
        return 4;
    }

    /*if (ioperm(led_port, 1, 1)) {
        printf("Unable to access port at %x: %s (%d)\n", led_port, strerror(errno), errno);*/
    if (iopl(3)) {
        printf("Unable to access port: %s (%d)\n", strerror(errno), errno);
	return 1;
    }

    switch (param) {
    case 0:
        setLanBypass(false);
        break;
    case 1:
        setLanBypass(true);
        break;
    case 2:
	lanBypassWatchdogDisable();
        break;
    case 3:
	lanBypassWatchdogSendAlive(watchdog_enable_value);
	break;
    case 4:
	/* First be sure that LAN bypass is _disabled_. Need to issue both
	 commands in case the watchdog has already triggered (first disable the
	 watchdog, then disable the bypass itself). */
        lanBypassWatchdogDisable();
	setLanBypass(false);
	/* Send an alive signal at 4 Hz (we the minimum frequency allowed by
	 this watchdog and configured by watchdog_enable_value is 2 Hz, we thus
         have some safety margin). */
	sleep.tv_sec = 0;
	sleep.tv_nsec = 250000000;
	while (true) {
	    lanBypassWatchdogSendAlive(watchdog_enable_value);
            nanosleep(&sleep, NULL);
	}
        // just to make the compiler shut up - never reach this point
        break;
    }

    return 0;
}
