#include <sys/io.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include "appliance.h"

int main(int argc, char* argv[])
{
    int param;

    if (argc != 2) {
	printf("Need value !\n");
        printf("0 ... LED off\n");
        printf("1 ... LED on\n");
        printf("2 ... LED blink (until process is killed)\n");
        return 2;
    }
    param = atoi(argv[1]);
    if (param < 0) {
	printf("Invalid value !\n");
        return 3;
    }

    if (! isIbase()) {
	printf("This is not an iBASE appliance. Can not set status LED!\n");
        return 4;
    }

    /*if (ioperm(led_port, 1, 1)) {
        printf("Unable to access port at %x: %s (%d)\n", led_port, strerror(errno), errno);*/
    if (iopl(3)) {
        printf("Unable to access port: %s (%d)\n", strerror(errno), errno);
	return 1;
    }

    switch (param) {
        /* Doh - the documention is wrong - the bit is inverted!. */
    case 1:
        setLedBit(false);
        break;
    case 0:
        setLedBit(true);
        break;
    case 2:
	while (1) {
	    setLedBit(false);
            usleep(500000);
	    setLedBit(true);
            usleep(500000);
	}
	break;
    }

    return 0;
}
